# -*- coding: utf-8 -*-
from sys import platform, executable, exit, version_info, stdin
from os import environ, getcwd, pathsep
from os.path import isfile, split, join
from subprocess import Popen
import optparse;
# dodanie głównego katalogu kasy do PYTHONPATH
if 'PYTHONPATH' in environ:
	environ['PYTHONPATH'] = getcwd() + pathsep + environ['PYTHONPATH']
else:
	environ['PYTHONPATH'] = getcwd()

def show_gui_error(text):
	if platform[:3] == 'win':
		from win32ui import MessageBox
		from win32con import MB_OK, MB_ICONERROR
		MessageBox(text, u'BŁĄD!', MB_OK | MB_ICONERROR)
	elif 'DISPLAY' in environ:
		from gtk import MessageDialog, MESSAGE_ERROR, BUTTONS_CLOSE, WIN_POS_CENTER
		dialog = MessageDialog(message_format=text, type=MESSAGE_ERROR, buttons=BUTTONS_CLOSE)
		dialog.set_title(u'BŁĄD!')
		dialog.set_position(WIN_POS_CENTER)
		dialog.run()

# odpowiednia wersja bootstrapmain dla obecnego interpretera
bootstrapmain = 'bootstrapmain-%d.%d.pyc' % (version_info[0], version_info[1])
if not isfile(bootstrapmain):
	if not stdin.isatty() or platform[:3] == 'win':
		try:
			show_gui_error(u'Brak plików binarnych wymaganych do uruchomienia!')
		except:
			pass
	print 'BLAD!: Brak plikow binarnych wymaganych do uruchomienia!'
	exit(-1)

parser = optparse.OptionParser()
parser.add_option('--bootSchemeId',
	action="store", dest="bootSchemeId",
	help="boot scheme id", default=None)
options, args = parser.parse_args()

if platform[:3] == 'win':
	# podmieniamy exeka pythona na python.exe (skrypt mógł być odpalony w pythonw.exe,
	# pod którym są problemy z przekierowywaniem standardowego wejścia i wyjścia)
	pythonPath = join(split(executable)[0], 'python.exe')

	popenParams = [pythonPath, bootstrapmain]
	if (options.bootSchemeId is not None):
		popenParams.append(u'--bootSchemeId')
		popenParams.append(options.bootSchemeId)

	# fix na uruchomienie pythona bez okna!
	import win32con
	# ponowne uruchomienie jako python.exe
	appProc = Popen(popenParams, env=environ, creationflags=win32con.CREATE_NO_WINDOW)
	exit(appProc.wait() & 0xff)
else:
	popenParams = [executable, bootstrapmain]
	if (options.bootSchemeId is not None):
		popenParams.append(u'--bootSchemeId')
		popenParams.append(options.bootSchemeId)

	# ponowne uruchomienie w tym samym interpreterze
	appProc = Popen(popenParams, env=environ)
	exit(appProc.wait() & 0xff)
